#| - ael - Sat Apr 25 22:08:08 1998

	These are new methods for old established protos. I moved the methods
for the andyplot-proto, derived from the scatterplot-proto,  to a file called
andyplot.lsp. This was part of a project to establish a clear line of descent
for protos, and avoid messing up other peoples' codes by changing the elemental
methods of the protos.

 - lea - |#


(defmeth graph-proto :do-key (c m1 m2)
  "
  The following essential keys are currently defined: typing them while a plot
active will give the following results:

                        h - help (this message)

q - remove the plot     a - adjust-to-data
u - update the plot
v - shrink the plot
V - grow the plot

n - move right          N - move down           z - zoom in
m - move left           M - move up             Z - zoom out

l - make the window large (of full screen-size)
s - make the window small (250 by 250)
C-m - choose-mouse-mode ('C-m' denotes control-m)
"
  (case c
	(#\a (send self :adjust-to-data))
	(#\h (princ
"
  The following keys are currently defined: typing them while a plot is
active will give the following results:

                        h - help (this message)

q - remove the plot     a - adjust-to-data
u - update the plot
v - shrink the plot
V - grow the plot
i - help

n - move right          N - move down           z - zoom in
m - move left           M - move up             Z - zoom out

l - make the window large (of full screen-size)
s - make the window small (250 by 250)
C-m - choose-mouse-mode ('C-m' denotes control-m)
")
	 )
	(#\i (send self :help))
	(#\l
 	 (let (
	       (screen-size (screen-size))
	       )
	   (send self :location 0 20)
	   (send self :size (first screen-size) (- (second screen-size) 20))
	   )
	 )
	(#\q (send self :remove))
	(#\s (send self :size 250 250))
	(#\u (send self :update-plot))
	(#\v (let((size (send self :size)))
	       (send self :size
		     (floor (* .9 (first size)))
		     (floor (* .9 (second size))))))
	(#\V (let((size (send self :size)))
	       (send self :size
		     (floor (* 1.1 (first size)))
		     (floor (* 1.1 (second size))))))

	(#\z (send self :shift 5 0 0)) ;; zoom in
	(#\Z (send self :shift 4 0 0)) ;; zoom out

	;; These are for keypad use:
	(#\C-m (send self :choose-mouse-mode))
	(#\= (send self :remove))
	(#\C-q (send self :remove)) ;; control characters work too!

	(#\7
	 (send self :location 0 20)
	 (send self :size 250 250)
	 )
	(#\9
	 (let ((screen-size (screen-size)))
	   (send self :location 0 20)
	   (send self :size (first screen-size) (- (second screen-size) 20))
	   )
	 )
	)
  nil
  )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;		The essential "get-screen-point-type" routine
;;
;; Hooray! I really had to work to find this in the documentation, the rats.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :center-on (&key (motion-on nil))
  (setq lps nil)
  (send self
	:while-button-down
	#'(lambda (x y) (setq lps (append lps (list (list x y)))))
	motion-on)
  (if lps (let* (
		 (a (first (first lps)))
		 (b (second (first lps)))
		 (c (first (first (last lps))))
		 (d (second (first (last lps))))
		 )
	    (list
	     (send self :canvas-to-real a b)
	     (send self :canvas-to-real c d)
	     (length lps)
	     )
	    )
    nil)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				plot-item
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defmeth graph-proto :plot-item (&optional new)
  "
	The idea of plot-item is to make the plot recall what was plotted in
it, so that if the range changes, it can be updated.

	I want to add this feature to the zoom, so that functions can be
continually updated to adjust to new range and domain values.

	Also so that data can be scoped.

 (plot sinc)
 (send my-plot :plot-item)

;; Now choose the mouse mode of Zoom!

	I created the :plot-item method so that I could control exactly what
gets plotted in a plot. It is a list of lists of things, each of which is
plotted whenever the :plot-item method is invoked without an argument. With an
argument, the 'plot-item slot is reset to that item.

	Now I think that only the :add-lines option of old won't work with
this. The problem is that those lines will be cleared, but they haven't been
recorded. I think that I'll introduce a slot for those lines that I want to
kill only (problem is that :clear-lines won't take as an argument those lines
that you want removed).
"
  (when new (setf (slot-value 'plot-item) new))
  (let (
	(line-colors *line-colors*)
	(stuff-to-plot (slot-value 'plot-item))
	(andy-options (slot-value 'andy-options))
	(lines-to-kill (slot-value 'lines-to-kill))
	line-color self.domain self.range xmin xmax
	x-coords-of-text
	y-coords-of-text
	texts
	)
    (if stuff-to-plot
	(let(
	     (count 0)
	     (axes (final (catch-keys '(:axes) andy-options)))
	     (vlabels
	      (not
	       (eval `(and ,@
			   (mapcar (lambda(x) (equalp "" x))
				   (send self :variable-label '(0 1)))))))
	     (stuff-to-plot
	      (if (listp stuff-to-plot) stuff-to-plot (list stuff-to-plot)))
	     )
	  (if lines-to-kill
	      (send self
		    :linestart-masked
		    lines-to-kill
		    (repeat t (length lines-to-kill))))
	  
	  (if axes
	      (if vlabels
		  (let() 
		    (send self :y-axis t t *y-tics*)
		    (send self :x-axis t t *x-tics*)
		    )
		(let()
		  (send self :y-axis t nil *y-tics*)
		  (send self :x-axis t nil *x-tics*)
		  )
		)
	    )
	  (setq
	   self.domain (send self :range 0)
	   xmin (first self.domain)
	   xmax (second self.domain)
	   )
	  
;;; ael: only the lines are going to be cleared: the points and strings can
;;; stay right where they are! Saves time, and it was unnecessary. The point of
;;; clearing is primarily so that I could clear out the functions. They need to
;;; be updated as the domain changes.
;;;	  (send self :clear-lines)
;;; Now I'm keeping the lines, and only masking them.
	  
	  (if axes
	      (let ()
		(if *y-axis*
		    (let ()
		      (setq self.range (send self :range 1))
		      (if (and
			   (> 0 (first self.domain))
			   (< 0 (second self.domain)))
			  (let ()
			    (send self :add-lines '(0 0) self.range)
			    (setq
			     lines-to-kill
			     (combine
			      lines-to-kill
			      (select-from-end (iseq (send self :num-lines))
					       (iseq 2))
			      )
			     )
			    )
			)
		      )
		  )
		(if *x-axis*
		    (let ()
		      (setq self.range (send self :range 1))
		      (if (and
			   (> 0 (first self.range))
			   (< 0 (second self.range)))
			  (let ()
			    (send self :add-lines self.domain '(0 0))
			    (setq
			     lines-to-kill
			     (combine
			      lines-to-kill
			      (select-from-end (iseq (send self :num-lines))
					       (iseq 2))
			      )
			     )
			    )
			)
		      )
		  )
		)
	    )
	  
	  (dolist
	   (i stuff-to-plot)
	   (if *use-color*
	       (let()
		 (setq line-colors (circulate line-colors)
		       line-color (first line-colors))
		 (if *verbose*
		     (format t
			     "Item ~d has color ~a.~%"
			     (incf count) (symbol-name line-color))
		   )
		 )
	     (setq line-color 'black)
	     )
	   (cond
	    ((functionp i)
	     (let* (
		    (x (rseq xmin xmax *points*))
		    (y (mapcar i x))
		    )
	       (apply
		#'send
		self
		:add-lines (list x y)
		(list
		 :color line-color
		 :width *line-width*
		 :type *line-type*
		 )
		))
	     (setq
	      lines-to-kill
	      (combine
	       lines-to-kill
	       (select-from-end (iseq (send self :num-lines))
				(iseq *points*)))
	      )
	     )
	    ((not (listp i))
	     ;; if it's not a list or function, do nothing.
	     )
	    ((stringp (first i))
	     (send self :text (first i) (second i) (third i)))
	    ((equal (first i) 'string)
	     (send self :text (second i) (third i) (fourth i)))
	    ((equal (first i) 'function)
	     (let* (
		    (x (rseq xmin xmax *points*))
		    (y (mapcar (second i) x))
		    )
	       (if (fourth i)
		   (let ()
		     (apply
		      #'send
		      self
		      :add-lines (list x y)
		      (list
		       :color (if (third i) (third i) line-color)
		       :width (if (fifth i) (fifth i) *line-width*)
		       :type (if (sixth i) (sixth i) *line-type*)
		       )
		      )
		     (setq
		      lines-to-kill
		      (combine
		       lines-to-kill
		       (select-from-end (iseq (send self :num-lines))
					(iseq *points*)))
		      )
		     )
		 (send
		  self
		  :add-points x y
		  :color (if (third i) (third i) line-color)
		  )
		 )
	       )
	     )
	    ((equal (first i) 'path)
	     (let (
		   (orig-color (send self :draw-color))
		   (patchcolor (if (third i) (third i) 'white))
		   (linecolor (if (fourth i) (fourth i) line-color))
		   (color (if (third i) (third i) 'white))
		   (tmp (second i))
		   )
	       (send self :draw-color patchcolor)
	       (send self :paint-poly tmp)
	       (send self :draw-color linecolor)
	       (send self :frame-poly tmp)
	       (send self :draw-color orig-color)
	       )
	     )
	    ((equal (first i) 'patch)
	     (let (
		   (orig-color (send self :draw-color))
		   (patchcolor (if (third i) (third i) 'white))
		   (linecolor (if (fourth i) (fourth i) line-color))
		   (tmp
		    (mapcar
		     (lambda(x)
		       (send self :scaled-to-canvas (first x) (second x)))
		     (second i)
		     )
		    )
		   )
	       (send self :draw-color patchcolor)
	       (send self :paint-poly tmp)
	       (send self :draw-color linecolor)
	       (send self :frame-poly tmp)
	       (send self :draw-color orig-color)
	       )
	     )
	    (t nil)
	    )
	   )
	  )
      )
    (setf (slot-value 'lines-to-kill) (rest lines-to-kill))
    )
  (slot-value 'plot-item)
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                             remove-plot-item
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :remove-plot-item (&rest e)
  "
;; Description:

	graph-proto :remove-plot-item (&rest e &key draw)

	Removes an item that you've added using add-plot-item.

;; Examples:

 (plot {cos x} {sin x} {x} -pi pi)
 (make-title \"Hello World\")

 ;; You can remove them sequentially:
 (send my-plot :remove-plot-item {x})
 (send my-plot :remove-plot-item {sin x})
 (send my-plot :remove-plot-item \"Hello World\")

 (plot {cos x} {sin x} {x} -pi pi)
 (make-title \"Hello World\")
 ;; or you can remove them all at once:
 (send my-plot :remove-plot-item {x} {sin x} \"Hello World\")

 (def x (rand.u 10))
 (def y (rand.u 10))
 (plot sin)
 (send my-plot :add (list 'points x y))
 (send my-plot :add (list 'lines x y))
 (send my-plot :remove-plot-item (list x y))
"
  (let (
	(new-plot-item (slot-value 'plot-item))
	keepers
	)
    (dolist
     (item e)
     (cond
      ((stringp item)
       (setq
	keepers
	(mapcar
	 (lambda(x) (if (listp x)
			(or (equalp item (first x)) (equalp item (second x)))))
	 new-plot-item
	 ))
       )
      ((and (listp item) (= (length item) 2))
       (setq
	keepers
	(mapcar
	 (lambda(x)
	   (if (listp x)
	       (and 
		(equalp (first item) (second x))
		(equalp (second item) (third x)))
	     ))
	 new-plot-item
	 ))
       )
      ((functionp item)
       (setq
	keepers
	(mapcar
	 (lambda(x)
	   (if (functionp x)
	       (equalp
		(get-lambda-expression x)
		(get-lambda-expression item))
	     (if (functionp (first x))
		 (equalp
		  (get-lambda-expression (first x))
		  (get-lambda-expression item))
	       (if (functionp (second x))
		   (equalp
		    (get-lambda-expression (second x))
		    (get-lambda-expression item))
		 ))))
	 new-plot-item
	 )
	)
       )
      )
     (if keepers
	 (setq
	  keepers
	  (second
	   (simul-keep-if keepers (iseq (length new-plot-item)) #'null)
	   )
	  new-plot-item (select new-plot-item keepers)
	  )
       )
     )
    (send self :clear)
    (send self :replot-item (if new-plot-item new-plot-item '(nil)))
    nil
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                        :replot-item
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :replot-item (&optional new)
  "
	I created the :replot-item method so that I could redraw exactly what
gets plotted in a plot.
"
  (when new (setf (slot-value 'plot-item) new))
  (let (
	(line-colors *line-colors*)
	(stuff-to-plot (slot-value 'plot-item))
	(andy-options (slot-value 'andy-options))
	(lines-to-kill (slot-value 'lines-to-kill))
	line-color self.domain self.range xmin xmax
	x-coords-of-text
	y-coords-of-text
	texts
	)
    (if stuff-to-plot
	(let(
	     (count 0)
	     (axes (final (catch-keys '(:axes) andy-options)))
	     (vlabels
	      (not
	       (eval `(and ,@
			   (mapcar (lambda(x) (equalp "" x))
				   (send self :variable-label '(0 1)))
			   )
		     )
	       )
	      )	     
	     (stuff-to-plot
	      (if (listp stuff-to-plot)
		  stuff-to-plot
		(list stuff-to-plot)
		)
	      )
	     )
	  (if axes
	      (if vlabels
		  (let() 
		    (send self :y-axis t t *y-tics*)
		    (send self :x-axis t t *x-tics*)
		    )
		(let()
		  (send self :y-axis t nil *y-tics*)
		  (send self :x-axis t nil *x-tics*)
		  )
		)
	    )
	  (setq self.domain (send self :range 0)
		xmin (first self.domain)
		xmax (second self.domain))

	  (send self :clear)
		
	  (if axes
	      (let ()
		(if *y-axis*
		    (let ()
		      (setq self.range (send self :range 1))
		      (if (and
			   (> 0 (first self.domain))
			   (< 0 (second self.domain)))
			  (send self :add-lines '(0 0) self.range)
			)
		      ))
		(if *x-axis*
		    (let ()
		      (setq self.range (send self :range 1))
		      (if (and
			   (> 0 (first self.range))
			   (< 0 (second self.range)))
			  (send self :add-lines self.domain '(0 0))
			)
		      ))
		)
	    )

	  (dolist
	   (i stuff-to-plot)
	   (if *use-color*
	       (let()
		 (setq line-colors (circulate line-colors)
		       line-color (first line-colors))
		 (if *verbose*
		     (format t
			     "Item ~d has color ~a.~%"
			     (incf count) (symbol-name line-color))
		   )
		 )
	     (setq line-color 'black)
	     )
	   (cond
	    ((functionp i)
	     (let* (
		    (x (rseq xmin xmax *points*))
		    (y (mapcar i x))
		    )
	       (apply
		#'send
		self
		:add-lines (list x y)
		(list
		 :color line-color
		 :width *line-width*
		 :type *line-type*
		 )
		))
	     (setq
	      lines-to-kill
	      (combine
	       lines-to-kill
	       (select-from-end (iseq (send self :num-lines))
				(iseq *points*)))
	      )
	     )
	    ((listp i)
	     (cond
	      ((or (stringp (first i)) (equal (first i) 'string))
	       (if (equal (first i) 'string) (setq i (rest i)))
	       (setq
		texts (combine texts (first i))
		x-coords-of-text (combine  x-coords-of-text (second i))
		y-coords-of-text (combine  y-coords-of-text (third i)))
	       )
	      ((equal (first i) 'points)
	       (printall 'adding-points i)
	       (send self :add-points
		     (second i)
		     (third i)
		     :color (if (fourth i) (fourth i) line-color)
		     :symbol (if (fifth i) (fifth i) *plot-symbol*)
		     )
	       (if (sixth i) 
		   (setq
		    texts (combine texts (sixth i))
		    x-coords-of-text (combine x-coords-of-text (second i))
		    y-coords-of-text (combine  y-coords-of-text (third i))
		    )
		 )
;;
;; The following redraw appears to be necessary in order to get the plot
;; symbols to work - unfortunately, it obliterates any text in the field. To
;; take care of that, I add all text last:
;;
	       #| - ael - Sun May 3 18:55:24 1998
;;	       (send self :redraw)
 - lea - |#
	       )
	      ((equal (first i) 'lines)
	       (send self :add-lines
		     (second i)
		     (third i)
		     :color (if (fourth i) (fourth i) line-color)
		     :width (if (fifth i) (fifth i) *line-width*)
		     :type (if (sixth i) (sixth i) *line-type*)
		     )
	       #| - ael - Sun May 3 18:55:30 1998
;;	       (send self :redraw)
 - lea - |#
	       )
	      ((equal (first i) 'function)
	       (let* (
		      (x (rseq xmin xmax *points*))
		      (y (mapcar (second i) x))
		      )
		 (if (fourth i)
		     (let ()
		       (apply
			#'send
			self
			:add-lines (list x y)
			(list
			 :color (if (third i) (third i) line-color)
			 :width (if (fifth i) (fifth i) *line-width*)
			 :type (if (sixth i) (sixth i) *line-type*)
			 )
			)
		       (setq
			lines-to-kill
			(combine
			 lines-to-kill
			 (select-from-end (iseq (send self :num-lines))
					  (iseq *points*)))
			)
		       )
		   (send
		    self
		    :add-points x y
		    :color (if (third i) (third i) line-color)
		    )
		   )
		 )
	       )
	      ((equal (first i) 'path)
	       (let (
		     (orig-color (send self :draw-color))
		     (patchcolor (if (third i) (third i) 'white))
		     (linecolor (if (fourth i) (fourth i) line-color))
		     (color (if (third i) (third i) 'white))
		     (tmp (second i))
		     )
		 (send self :draw-color patchcolor)
		 (send self :paint-poly tmp)
		 (send self :draw-color linecolor)
		 (send self :frame-poly tmp)
		 (send self :draw-color orig-color)
		 )
	       )
	      ((equal (first i) 'patch)
	       (let (
		     (orig-color (send self :draw-color))
		     (patchcolor (if (third i) (third i) 'white))
		     (linecolor (if (fourth i) (fourth i) line-color))
		     (color (if (third i) (third i) 'white))
		     (tmp
		      (mapcar
		       (lambda(x)
			 (send self :scaled-to-canvas (first x) (second x)))
		       (second i)
		       )
		      )
		     )
		 (send self :draw-color patchcolor)
		 (send self :paint-poly tmp)
		 (send self :draw-color linecolor)
		 (send self :frame-poly tmp)
		 (send self :draw-color orig-color)
		 )
	       )
	      (t ; this should be a pair of list (or vectors), which will be
		 ; plotted:
	       (if *lines*
		   (let ()
		     (send self :add-lines (first i) (second i)
			   :color (if (third i) (third i) line-color)
			   :width (if (fourth i) (fourth i) *line-width*)
			   :type (if (fifth i) (fifth i) *line-type*)
			   )
		     #| - ael - Sun May 3 18:55:53 1998
;;		     (send self :redraw)
 - lea - |#
		     )
		 ;; otherwise, points:
		 (let()
		   (if (and *point-labels*
			    (= (length *point-labels*)
			       (length (first i))))
		       (let ()
			 (send self :add-points (first i) (second i)
			       :color line-color
			       :symbol *plot-symbol*
			       :point-labels *point-labels*
			       )
			 #| - ael - Sun May 3 18:56:01 1998
;;			 (send self :redraw)
 - lea - |#
			 (setq
			  texts (combine texts *point-labels*)
			  x-coords-of-text (combine x-coords-of-text (first i))
			  y-coords-of-text (combine  y-coords-of-text (second i))
			  )
			 )
		     (let ()
		       (send self :add-points (first i) (second i)
			     :color line-color
			     :symbol *plot-symbol*
			     )
		       #| - ael - Sun May 3 18:56:10 1998
;;		       (send self :redraw)
 - lea - |#
		       )
		     )
		   )
		 )
	       )
	      )
	     )
	    ((vectorp i)
	     (setq tmp (iseq (length i)))
	     (if *lines*
		 (let ()
		   (send self :add-lines tmp i :color line-color
			 :width *line-width*)
		   #| - ael - Sun May 3 18:56:20 1998
;;		   (send self :redraw)
 - lea - |#
		   )
	       ;; otherwise, points:
	       (let()
		 (if (and *point-labels*
			  (= (length *point-labels*)
			     (length (first i))))
		     (let ()
		       (send self :add-points tmp i
			     :point-labels *point-labels*
			     :color line-color)
		       #| - ael - Sun May 3 18:56:29 1998
;;		       (send self :redraw)
 - lea - |#
		       (setq
			texts (combine texts *point-labels*)
			x-coords-of-text (combine x-coords-of-text (first i))
			y-coords-of-text (combine  y-coords-of-text (second i))
			)
		       )
		   (let ()
		     (send self :add-points tmp i 
			   :symbol *plot-symbol*
			   :color line-color)
		     #| - ael - Sun May 3 18:56:38 1998
;;		     (send self :redraw)
 - lea - |#
		     )
		   )
		 )
	       )
	     )
	    (t
	     (print "can't handle this plot-item yet!")
	     )
	    )
	   )
	  )
      )
    ;; I do this last, so that the redraw commands after add-points doesn't
    ;; erase the labels:
    (send self :slot-value 'text (list texts x-coords-of-text y-coords-of-text))
    (send self :text texts x-coords-of-text y-coords-of-text)
    )
  (slot-value 'plot-item)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                             add-plot-item
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :add-plot-item (&rest e)
  "
;; Description:

	graph-proto :add-plot-item (&rest e &key draw)

	This method adds things to a plot. For the moment the list includes
 the following:

	(list string x y)
	(list 'string string x y)

	(list 'function f color lines-on width type)
	(list 'lines x y color width type)
	(list 'points x y color symbol point-labels)

	(list 'point-patterns x y color(s) symbol(s) point-labels(s))
		point-patterns are like points, except that a list of colors,
		symbols, and point-labels can provided (rather than a single
		color and symbol). 

	(list 'polka-dots x y radius type fill-color rim-color
				 &optional rotation)
		polka-dots are scaleable symbols. They're created by making
		patches (see below). Available types are:
		  circle, box, triangle, x, cross, +, diamond, stick
		and since all can be rotated other symbols can be created.

	(list 'path path patch-color line-color)
		paths are lists of coordinates which hook back on themselves at
		the end). Paths are in physical screen coordinates.
	(list 'patch path patch-color line-color)
		patches are like paths, except that they're in plot
		coordinates. 

	Default is to update the plot, calling method plot-item. These are the
 sorts of plot-items you can pass:

;; Examples:
 (new-plot)
 (lines off)
 (plot (* 2 (rand.n 10)) (* 2 (rand.n 10)))
 (send my-plot :add-plot-item (list 'lines (rand.n 10) (rand.n 10)))
 (send my-plot :add-plot-item (func f(x) x^2))

 (plot (* 2 (rand.n 10)) (* 2 (rand.n 10)))
 (send my-plot :add-plot-item
   (list 'lines (rand.n 10) (rand.n 10) 'red)
   (list 'function (func f(x) x) 'blue 'points)
   (list 'function (func f(x) x^2) 'blue 'lines)
   )

 (plot (* 2 (rand.n 10)) (* 2 (rand.n 10)))
 (send my-plot :add-plot-item
   (list 'polka-dots (rand.u 10) (rand.u 10) .1 'circle 'blue 'red))
"
  (let (
	(draw (if (grep '(:draw) e)
		       (first (catch-keys '(:draw) e))
		     t))
	(e (remove-keys '(:draw) e))
	(tmp e)
	)
    (dolist
     (i e)
     (cond
      ((not (listp i))
       ;; if i's not a list, do nothing.
       )
      ((stringp (first i))
       )
      ((functionp (first i))
       )
      ((equal (first i) 'string)
       )
      ((equal (first i) 'points)
       (let* (
	      (x (second i))
	      (y (third i))
	      (labels (if (sixth i) (sixth i) *point-labels*))
	      (label-test (= (length x) (length labels)))
	      )
	 (send self :add-points
	       x y
	       :color (if (fourth i) (fourth i) *draw-color*)
	       :symbol (if (fifth i) (fifth i) *plot-symbol*)
	       :point-labels (if label-test labels)
	       )
	 (if label-test
	     (let ((text (send self :slot-value 'text)))
	       (send self :slot-value 'text
		     (if text
			 (list 
			  (combine (first text) labels)
			  (combine (second text) x)
			  (combine (third text) y)
			  )
		       (list labels x y)
		       )
		     )
	       )
	   )
	 )
       )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Mon Jan 24 10:44:33 EST 2000
;;
;;                    Going to add "point-patterns"...
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ((equal (first i) 'point-patterns)
       (let* (
	      (x (mapcar #'list (second i)))
	      (y (mapcar #'list (third i)))
	      (n (length x))
	      (colors (fourth i))
	      (colors (if (listp colors) colors (repeat colors n)))
	      (symbols (fifth i))
	      (symbols (if (listp symbols) symbols (repeat symbols n)))
	      (labels (sixth i))
	      (labels (if (listp labels) (mapcar #'list labels)))
	      )
	 (mapcar
	  (lambda(x y color symbol label)
	    (send self :add-plot-item
		  (list 
		   'points
		   x y
		   color
		   symbol
		   label
		   )
		  :draw nil
		  )
	    )
	  x y colors symbols labels
	  )
	 )
       )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Sat Feb 5 10:18:42 EST 2000
;;
;;                    Going to add "polka-dots"...
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ((equal (first i) 'polka-dots)
       (let* (
	      (x (second i))
	      (y (third i))
	      (n (length x))
	      (radius (fourth i))
	      (type (fifth i))
	      ;; is there an eighth entry? if so, it's a rotation angle
	      (rotate (if (eighth i)
			  (case type
				((box x)
				 (+ (eighth i) pi/4))
				(t (eighth i)))
			(case type
			      ((box x)
			       pi/4)
			      (t 0))
			)
		      )
	      ;; make the list of points:
	      (rim 
	       (* radius 
		  (case type
			((cross + x)
			 (* (exp (* (complex 0 1) rotate))
			    '(1 0 #C(0 1) 0 -1 0 #C(0 -1) 0 1)))
			(t
			 (exp
			  (*
			   (complex 0 1)
			   (+
			    rotate
			    (rseq 0 (* 2 pi)
				  (case type
					((circle) 20)
					((triangle) 4)
					((diamond box) 5)
					(t 3))
				  ))
			   )))
			)
		  )
	       )
	      (imagrim (imagpart rim))
	      (realrim (realpart rim))
	      ;; wrap it:
	      (imagrim (combine (butlast imagrim) (first imagrim)))
	      (realrim (combine (butlast realrim) (first realrim)))
	      
	      (fill-colors (sixth i))
	      (fill-colors (if (listp fill-colors) 
			       fill-colors
			     (repeat fill-colors n)))
	      (rim-colors (seventh i))
	      (rim-colors (if (listp rim-colors) 
			       rim-colors
			     (repeat rim-colors n)))
	      )
	 #|
	 (apply #'send self :add-plot-item
		(mapcar
		 (lambda(x y fill-color rim-color)
		   (list
		    'patch
		    (transpose (list (+ x realrim) (+ y imagrim)))
		    fill-color
		    rim-color
		    )
		   )
		 x y fill-colors rim-colors
		 )
		)
|#
	 (mapcar
	  (lambda(x y fill-color rim-color)
	    (send self :add-plot-item
		  (list
		   'patch
		   (transpose (list (+ x realrim) (+ y imagrim)))
		   fill-color
		   rim-color
		   )
		  :draw nil
		  )
	    )	    
	  x y fill-colors rim-colors
	  )
	 )
       )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      
      ((equal (first i) 'lines)
       (send self :add-lines
	     (second i)
	     (third i)
	     :color (if (fourth i) (fourth i) *draw-color*)
	     :width (if (fifth i) (fifth i) *line-width*)
	     :type (if (sixth i) (sixth i) *line-type*)
	     )
       )      
      ((equal (first i) 'function)
       )
      ((equal (first i) 'path)
       )
      ((equal (first i) 'patch)
       )
      (t
       (print "Sorry, can't add this type of plot-item yet!")
       )
      )
     )
    (setf (slot-value 'plot-item) (append (slot-value 'plot-item) e))
    (if draw (send self :plot-item))
    )
  nil
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                             add
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :add (&rest e)
  "
;; Description:

	graph-proto :add (&rest e &key draw)

	I'm continually adding things that can be added to a plot. For the
moment the list includes lines, points, strings, functions, and patches (or
paths, which are lists of coordinates which hook back on themselves at the
end).

	Default is to update the plot, calling method plot-item. These are the
sorts of plot-items you can pass:

	(list string x y)
	(list 'string string x y)
	(list 'points x y color symbol point-labels)
	(list 'lines x y color width type)
	(list 'function f color lines-off width type)
	(list 'path path patch-color line-color)
	(list 'patch path patch-color line-color)

;; Examples:
 (new-plot)
 (lines off)
 (plot (* 2 (rand.n 10)) (* 2 (rand.n 10)))
 (send my-plot :add (list 'lines (rand.n 10) (rand.n 10)))
 (send my-plot :add (list (func f(x) x^2)))

 (plot (* 2 (rand.n 10)) (* 2 (rand.n 10)))
 (send my-plot :add
   (list \"howdy\" 0 1)
   (list 'lines (rand.n 10) (rand.n 10) :color 'red)
   (list 'points (rand.n 10) (rand.n 10) :color 'red :symbol 'wedge1)
   (list 'function (func f(x) x) :color 'blue :lines-off t :type 'dashed)
   (list 'function (func f(x) x^2) :color 'blue :width 2)
   )
"
  (let (
	(draw (if (grep '(:draw) e)
		       (first (catch-keys '(:draw) e))
		     t))
	(e (remove-keys '(:draw) e))
	)
    (dolist
     (i e)
     (let* (
	    (keys
	     (catch-keys
	      '(:color :symbol :point-labels :width :type :num-points :lines-off)
	      i)
	     )
	    (color (if (elt keys 0) (elt keys 0) *draw-color*))
	    (symbol (if (elt keys 1) (elt keys 1) *plot-symbol*))
	    (point-labels (elt keys 2))
	    (width (if (elt keys 3) (elt keys 3) *line-width*))
	    (type (if (elt keys 4) (elt keys 4) *line-type*))
	    (num-points (if (elt keys 5) (elt keys 5) *points*))
	    (lines-off (elt keys 6))
	    )
       (cond
	((not (listp i))
	 ;; if i's not a list, do nothing.
	 )
	((stringp (first i))
	 (setf (slot-value 'plot-item) (append (slot-value 'plot-item) (list i)))
	 )
	((functionp (first i))
	 (setf (slot-value 'plot-item)
	       (append (slot-value 'plot-item)
		       (list (list 
			'function
			(first i)
			color
			(not lines-off)
			width
			type
			))
		       ))
	 )
	((equal (first i) 'string)
	 (setf (slot-value 'plot-item)
	       (append (slot-value 'plot-item) (list (rest i))))
	 )
	((equal (first i) 'points)
	 (setq point-labels (if point-labels point-labels
			      (if (= (length (second i))
				     (length *point-labels*))
				  *point-labels*
				nil)))
	 (send self :add-points
	       (second i)
	       (third i)
	       :color (if color color *draw-color*)
	       :symbol (if symbol symbol *plot-symbol*)
	       :point-labels point-labels
	       )
	 (setf (slot-value 'plot-item)
	       (append (slot-value 'plot-item)
		       (list (list 
			'points
			(second i)
			(third i)
			color
			symbol
			point-labels
			))
		       ))
	 )
	((equal (first i) 'lines)
	 (send self :add-lines
	       (second i)
	       (third i)
	       :color (if color color *draw-color*)
	       :width (if width width *line-width*)
	       :type (if type type *line-type*)
	       )
	 (setf (slot-value 'plot-item)
	       (append (slot-value 'plot-item)
		       (list (list 
			'lines
			(second i)
			(third i)
			color
			width
			type
			))
		       ))
	 )
	((equal (first i) 'function)
	 (setf (slot-value 'plot-item)
	       (append (slot-value 'plot-item)
		       (list (list 
			'function
			(second i)
			color
			(not lines-off)
			width
			type
			))
		       ))
	 )
	((equal (first i) 'path)
	 (setf (slot-value 'plot-item) (append (slot-value 'plot-item) (list i)))
	 )
	((equal (first i) 'patch)
	 (setf (slot-value 'plot-item) (append (slot-value 'plot-item) (list i)))
	 )
	(t
	 (print "Sorry, can't add this type of plot-item yet!")
	 )
	)
       )
     )
    (if draw (send self :plot-item))
    )
  nil
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                        update-plot
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :update-plot (&rest args)
  (send self :plot-item)
  (send self :adjust-to-data)
  (send self :plot-item)
  (values)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                Reworked methods:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                new add-function:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :add-function
  (f xmin xmax &rest args
     &key (num-points 50)
          (line-color nil)
	  (lines-on *lines*)
     )
  "Message args: (f xmin xmax &key (num-points 50) (line-color nil)
Adds plot of function F of one real variable over the range between xmin
and xmax to the plot. The function is evaluated at NUM-POINTS points."
  (unless (= 2 (send self :num-variables)) (error "only works for 2D plots"))
  (let* (
	 (x (rseq xmin xmax num-points))
         (y (mapcar f x))
	 )
    (send self
	  :add
	  (list
	   'function f
	   :color (if line-color line-color *draw-color*)
	   :lines-off (not lines-on)
	   )
	  :draw nil)
    (if *use-color*
	(let ((line-color (if line-color line-color *draw-color*)))
	  (send self :draw-color line-color)
	  (if lines-on (apply #'send self :add-lines (list x y) args)
	    (apply #'send self :add-points (list x y) args))
	  (send self :draw-color *draw-color*)
	  )
      (if lines-on (apply #'send self :add-lines (list x y) args)
	(apply #'send self :add-points (list x y) args))
      )
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				Zoom!
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :zoom (&key (factor .9) (draw t))
  (let ((mouse-info (send self :center-on)))
    (if mouse-info
	(if (> 100 (third mouse-info)) ; held down, so zoom out
	    (let ()
	      (if (not *zoom-out-factor*) (setq *zoom-out-factor* 1.1))
	      (send self :zoomer (first mouse-info) :factor *zoom-out-factor*)
	      )
	  (let ()
	    (if (not *zoom-in-factor*) (setq *zoom-in-factor* .9))
	    (send self :zoomer (first mouse-info) :factor *zoom-in-factor*)
	    )
	  ) 
      )
    mouse-info
    )
  )

(defmeth graph-proto :do-zoom-in (x y m1 m2)
  (if (or m1 m2)
      (send self :adjust-to-data)
    (let* ((oldx x)
	   (oldy y)
	   (old-draw-mode (send self :draw-mode))
	   (rect (progn (send self 
			      :while-button-down
			      #'(lambda (nx ny)
				  (send self :draw-mode 'xor)
				  (send self :frame-rect x y
					(- oldx x) (- oldy y))
				  (send self :frame-rect x y
					(- nx x) (- ny y))
				  (setf oldx nx)
				  (setf oldy ny)))
			(list x y (- oldx x) (- oldy y))))
	   (l (nth 0 rect))
	   (to (nth 1 rect))
	   (w (nth 2 rect))
	   (h (nth 3 rect))
	   (lb (send self :canvas-to-scaled l (+ to h)))
	   (tr (send self :canvas-to-scaled (+ l w) to))
	   (xmin (nth 0 lb))
	   (xmax (nth 0 tr))
	   (ymin (nth 1 lb))
	   (ymax (nth 1 tr))
	   )
      (if (= 0 (* w h))
	  (let* (
		 (current-domain (send self :scaled-range 0))
		 (current-range (send self :scaled-range 1))
		 (xmin (nth 0 current-domain))
		 (xmax (nth 1 current-domain))
		 (ymin (nth 0 current-range))
		 (ymax (nth 1 current-range))
		 (xcenter (mean (list xmax xmin)))
		 (ycenter (mean (list ymax ymin)))
		 (xdiff (/ (* *zoom-out-factor* (- xmax xmin)) 2))
		 (ydiff (/ (* *zoom-out-factor* (- ymax ymin)) 2))
		 (xmin (- xcenter xdiff))
		 (xmax (+ xcenter xdiff))
		 (ymin (- ycenter ydiff))
		 (ymax (+ ycenter ydiff))
		 )
	    ;; it would be better to do this using the :scale option (see
	    ;; vista.lsp)
	    (send self :set-ranges
		  (min xmin xmax) (max xmin xmax)
		  (min ymin ymax) (max ymin ymax)
		  )
	    (send self :draw-mode old-draw-mode)
	    )
	(list
	 (send self :frame-rect l to w h)
	 (send self :draw-mode old-draw-mode)
	 (send self :set-ranges
	       (min xmin xmax) (max xmin xmax)
	       (min ymin ymax) (max ymin ymax)
	       )
	 )
	)
      )
    )
;;   (send self :redraw)
  (send self :plot-item)
  )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				center-on-it
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :center-on-it (&key (draw t))
  "
	Centers on a point of your choice in the viewing plane, without zooming
in or out.
"
  (let ((mouse-info (send self :center-on)))
    (if mouse-info
	(send self :zoomer (first mouse-info) :factor 1.0))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				Zoom-box
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :zoom-box (&key (draw t))
  (let ((mouse-info (send self :center-on)))
    (if mouse-info
	(if (> (third mouse-info) 100)
	    (send self :zoomer-box (first mouse-info) (second mouse-info))
	  (send self :zoom-in :factor 2)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                         zoomer
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :zoomer (coords &key (factor .9) (draw t))

  (let* (
	 ;; First thing is to get the current domain and range:
	 (self.domain (send self :range 0))
	 (self.range (send self :range 1))
	 
	 ;; then get the new spread:
	 (xdiff (* .5 factor (- (second self.domain) (first self.domain))))
	 (ydiff (* .5 factor (- (second self.range) (first self.range))))
	 
	 ;; obtain the new domain and range,
	 (self.domain (list (- (first coords) xdiff) (+ (first coords) xdiff)))
	 (self.range (list (- (second coords) ydiff) (+ (second coords) ydiff)))
	 )
    
    ;; and now actually set the new domain and range:
    (send self :update-viewing-rectangle self.domain self.range draw)
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				Zoomer-box
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :zoomer-box (c1 c2 &key (draw t))
  (let* (
	 ;; then get the new spread:
	 (xmin (min (first c1) (first c2)))
	 (xmax (max (first c1) (first c2)))
	 (ymin (min (second c1) (second c2)))
	 (ymax (max (second c1) (second c2)))
	 )
    
    ;; and now actually set the new domain and range:
    (send self :update-viewing-rectangle (list xmin xmax) (list ymin ymax) draw)
    )
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                         zoom-in
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :zoom-in (&key (factor .9) (draw t))
  (let* (
	 ;; First thing is to get the current domain and range:
	 (self.domain (send self :range 0))
	 (self.range (send self :range 1))
	 
	 (coords (list (mean self.domain) (mean self.range)))
	 
	 ;; then get the new spread:
	 (xdiff (* .5 factor (- (second self.domain) (first self.domain))))
	 (ydiff (* .5 factor (- (second self.range) (first self.range))))
	 
	 ;; obtain the new domain and range,
	 (self.domain (list (- (first coords) xdiff) (+ (first coords) xdiff)))
	 (self.range (list (- (second coords) ydiff) (+ (second coords) ydiff)))
	 )
    ;; and now actually set the new domain and range:
    (send self :update-viewing-rectangle self.domain self.range draw)
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				:update-viewing-rectangle
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :update-viewing-rectangle (domain range &optional (draw t))
  (apply #'send self :range 0 domain)
  (apply #'send self :range 1 range)
  (if draw (send self :plot-item))
  (values)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                           true-axes
;;
;; Here's a method to plot the true axes in a 3-d plot:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :true-axes ()
  "
This is a method to plot the true axes in a 2-d plot.

;; Examples:
 (send my-plot :true-axes)
"
  (let (
	(xs (send self :range 0))
        (ys (send self :range 1))
	(zs (send self :range 2))
	)
    (send self :add-lines
	  (list
	   (list (half (abs (- (second xs) (first xs)))) 0 0 0 0)
	   (list 0 0 (half (abs (- (second ys) (first ys)))) 0 0)
	   (list 0 0 0 0 (half (abs (- (second zs) (first zs)))))
	   )
	  )
    (send self :add-points
	  (list
	   (list 0 (half (abs (- (second xs) (first xs)))) 0 0)
	   (list 0 0 (half (abs (- (second ys) (first ys)))) 0)
	   (list 0 0 0 (half (abs (- (second zs) (first zs)))))
	   )
	  :point-labels *true-axes-labels*
	  )
    (send self :showing-labels t)
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                           true-axes
;;
;; Here's a method to plot the real axes in a 3-d plot:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :real-axes ()
  "
This is a method to plot the real axes in a 2-d plot.
;; Examples:
 (send my-plot :real-axes)
"
  (send self :true-axes)
  (send self
	:selection
	(iseq
	 (- (send self :num-points) 4) (- (send self :num-points) 1))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                text
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :text (text x y &key (h 0) (v 0) draw)
  (if (listp text)
      (mapcar (lambda(x y z) (send self :text x y z :draw draw)) text x y)
    (let* (
	   (coords (send self :real-to-canvas x y))
	   (x (first coords))
	   (y (second coords))
	   )
      (send self :draw-text text x y h v)
      )
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                           andy-add-points
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :andy-add-points (&rest e)
  "
 (plot (rand.u 100) (rand.u 100))
 (send my-plot :andy-add-points (rand.n 10) (rand.n 10))
"
  (let (
	(x (first e))
	(y (second e))
	(z (if (= 3 (length e)) (third e) nil))
	)
    (if z (send self :add-points x y z)
      (send self :add-points x y))
    (setf (slot-value 'plot-item)
	  (if z (append (slot-value 'plot-item) (list (list x y z)))
	    (append (slot-value 'plot-item) (list (list x y)))
	    )
	  )
    )
  nil
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                             andy-options
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :andy-options (&rest e)
  "
"
  (let ((options (slot-value 'andy-options)))
    (if e (setf (slot-value 'andy-options) (combine options e))
      options
      )
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                             add-to-plot
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :add-to-plot (&rest e)
  "
 (plot cos -pi pi)
 (message-dialog \"In the next dialog box, type in

                      (func f(x) sin x)

 and see what happens!\")
 (send my-plot :add-to-plot)
"
  (let (
	(bing (if (not e)
		  (get-string-dialog
		   "What do you want to add? Enter a valid lisp expression:"
		   :initial ""
		   :location (send self :location)
		   )
		)
	      )
	bong
	)
    (if e (send self :add-plot-item e)
      (let ()
	(setq bong (eval (read (make-string-input-stream bing))))
	(setf (slot-value 'plot-item)
	      (append (slot-value 'plot-item) (list bong)))
	(send self :plot-item)
	)
      )
    )
  nil
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                             points+-sd
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :points+-sd (&rest e)
  "
;; Description:

	method graph-proto :points+-sd (x y sd
		&key
		(color 'black)
		(symbol 'diamond)
		(type 'solid)
		(line-size 2)
		(point-size 3)
		)

	This method provides the means to put points and their standard
deviations on a plot. Options are for color of lines and points, symbol of
points, type of line, and size of lines.

;; Examples:

 (plot sin)
 (send my-plot :points+-sd (rand.u 10) (rand.u 10) (rand.u 10))

 (plot)
 (send my-plot :points+-sd (rand.u 10) (rand.u 10) (rand.u 10)
    :color 'blue :symbol 'wedge1 :type 'dashed :line-size 2)
 (send my-plot :range '(0 1) '(0 -1) '(1 2))

 (plot)
 (send my-plot :points+-sd (rand.u 10) (rand.u 10) (rand.u 10)
    :type 'dashed :color 'blue :symbol 'wedge1 :point-size 1 :line-size 1)
 (send my-plot :range '(0 1) '(0 -1) '(1 2))
"
  (let* (
	 (args (catch-keys '(:color :symbol :type :line-size :point-size) e))
	 (e (remove-keys '(:color :symbol :type :line-size :point-size) e))

	 (color (if (first args) (first args) 'black))
	 (symbol (if (second args) (second args) 'diamond))
	 (type (if (third args) (third args) 'solid))
	 (line-size (if (fourth args) (fourth args) 2))
	 (point-size (if (fifth args) (fifth args) 3))
	 (x (first e))
	 (y (second e))
	 (z (third e))
	 )
    (setf (slot-value 'plot-item)
	  (append (slot-value 'plot-item)
		  (mapcar
		   (lambda(x y z)
		     (list 'lines (list x x) (list (- y z) (+ y z))
			   color line-size type)
		     )
		   x y z)
		  (mapcar
		   (lambda(x y)
		     (list 'points (list x) (list y) color symbol point-size)
		     )
		   x y)
		  )
	  )
    (send self :plot-item)
    nil
    )
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                           :points-to-histogram
;;
(defmeth graph-proto :points-to-histogram
  (x y
     &key
     (fill-color 'blue)
     (line-color 'black)
     (squeeze 2)
     (basement 0)
     )
  "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; points-to-histogram Doc:    Creation Date:3/13/97        Author: Andy Long
;;
;; Description/Arguments:

        graph-proto method :points-to-histogram
  (x y
     &key
     (fill-color 'blue)
     (line-color 'black)
     (squeeze 2)
     (basement 0)
     )
  
	This method adds a histogram to a plot.

;; Examples:

 ;; Histograms are ordinarily drawn to the x-axis:
 (plot :show-window t)
 (send my-plot :points-to-histogram (rseq -.5 .5 10) (rand.u 10)
   :fill-color 'red :line-color 'black)
 (send my-plot :points-to-histogram (rseq -.5 .5 10) (- (rand.u 10))
   :fill-color 'yellow :line-color 'black)

 ;; Histograms will lay on top of each other:
 (plot :show-window t)
 (send my-plot :points-to-histogram (rseq -.5 .5 10) (rand.u 10)
   :fill-color 'red :line-color 'black)
 (send my-plot :points-to-histogram (rseq -.5 .5 10) (rand.u 10)
   :fill-color 'yellow :line-color 'black)

 ;; Appropriate shifts will put histograms next to each other:
 (plot :show-window t)
 (send my-plot :points-to-histogram (- (rseq -.5 .5 3) .125) (rand.u 3)
   :fill-color 'red :line-color 'black :squeeze 4)
 (send my-plot :points-to-histogram (+ (rseq -.5 .5 3) .125) (rand.u 3)
   :fill-color 'yellow :line-color 'black :squeeze 4)

 ;; Adjust bottom of histograms using basement:
 (plot :show-window t)
 (send my-plot :points-to-histogram (- (rseq -.5 .5 3) .125) (rand.u 3)
   :fill-color 'red :line-color 'black :squeeze 4)
 (send my-plot :points-to-histogram (+ (rseq -.5 .5 3) .125) (rand.u 3)
   :fill-color 'yellow :line-color 'black :squeeze 4 :basement -.5)

 ;; Stack histograms using basement:
 (plot :show-window t)
 (def y (* .5 (rand.u 10)))
 (send my-plot :points-to-histogram (rseq -.5 .5 10) y
   :fill-color 'red :line-color 'black)
 (send my-plot :points-to-histogram (rseq -.5 .5 10) (+ y (* .5 (rand.u 10)))
   :fill-color 'yellow :line-color 'black :basement y)
"
  (let (
	(xdiff (/ (- (second x) (first x)) squeeze))
	(b (if (numberp basement) (repeat basement (length x)) basement))
	)
    (mapcar
     (lambda(x y b)
       (let (
	     (x1 (- x xdiff))
	     (x2 (+ x xdiff))
	     )
	 (send self :add-plot-item
	       (list
		'patch
		(list (list x1 b)(list x2 b)(list x2 y)(list x1 y)(list x1 b))
		fill-color
		line-color
		)
	       :draw nil
	       )
	 )
       )
     x y b
     )
    )
  (send self :plot-item)
  nil
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				:postscript-image
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :postscript-image ()
  "Method args: ()
Opens dialog to set postscript image options."
  (let* (
	 ;; Prompts for editable-text fields:
	 (name-prompt
	  (send text-item-proto
		:new "Postscript Filename (.ps added automatically):"))
	 (fmt-prompt    (send text-item-proto :new "Axes label format:"))
	 (bul-prompt    (send text-item-proto :new "Bullet Size:      "))
	 (width-prompt  (send text-item-proto :new "PS file width:    "))
	 (height-prompt (send text-item-proto :new "PS file Height:   "))

	 ;; the editable-text themselves:
	 (name (send edit-text-item-proto :new "image" :text-length 40))
	 (fmt (send edit-text-item-proto :new "3" :text-length 1))
	 (bul (send edit-text-item-proto :new "1" :text-length 1))
	 (width (send edit-text-item-proto :new "400" :text-length 3))
	 (height (send edit-text-item-proto :new "400" :text-length 3))

	 ;; Toggles (options to the postscript command):
	 (toggle-label (send text-item-proto :new "Toggles:"))
	 (axes (send toggle-item-proto :new "Axes" :value t))
	 (box (send toggle-item-proto :new "Enclosing Box" :value t))
	 (axes-box (send toggle-item-proto :new "Axes Box" :value nil))
	 (no-squish (send toggle-item-proto :new "No Squish" :value nil))
         (show (send toggle-item-proto :new "Show (ghostview)" :value t))

	 ;; Buttons (ok or cancel):
	 (cancel (send modal-button-proto :new "Cancel"))
	 (ok
	  (send modal-button-proto
		:new "OK"
		:action #'(lambda() t)
		))

	 ;; Here's the dialog:
	 (items
	  (send modal-dialog-proto :new
		(list
		 (list
		  (list (list bul-prompt bul)
			(list width-prompt width)
			(list height-prompt height)
			(list fmt-prompt fmt))
		  (list toggle-label axes box axes-box no-squish
			#+unix show
			)
		  )
		 name-prompt
		 name
		 (list ok cancel)
		 )
		:default-button ok
		))
	 )

    ;; Fire up the dialog:
    (setf items (send items :modal-dialog))

    ;; Now if we got a positive response, and we got a filename, then call
    ;; postscript: 
    (if items
	(let ((file (send name :text)))
	  (if (string= file "")
	      (let ()
		(message-dialog "Sorry - you must provide a filename.")
		(send self :postscript-image)
		)
	    (let ()
	      (setq file (strcat file ".ps"))
	      (postscript file
			  :bulsize (read-from-string (send bul :text))
			  :width (read-from-string (send width :text))
			  :height (read-from-string (send height :text))
			  :no-axes (not (send axes :value))
			  :no-box (not (send box :value))
			  :axes-box (send axes-box :value)
			  :no-squish (send no-squish :value)
			  :fmt (strcat "~," (send fmt :text)
				       "," (send fmt :text) "g")
			  )
	      #+unix (if (send show :value) (eval `(gv ,file)))
	      ))))
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				:set-andy-options
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth graph-proto :set-andy-options ()
  "Method args: ()
Opens dialog to set plot options. Items are obtained using the
:make-options-dialog-items message."
  (let* (
	 (x-label (send text-item-proto :new "Mouse-Modes:"))
	 (y-label (send text-item-proto :new "Basic Color:"))
	 (toggle-label (send text-item-proto :new "Toggles:"))
	 
	 (prompt (send text-item-proto :new "Title:"))
	 (name (send edit-text-item-proto
		     :new (if (send self :title) (send self :title) "")
		     :text-length 35))
	 
	 (promptx (send text-item-proto :new "X-label:"))
	 (namex (send edit-text-item-proto
		      :new (if (send self :variable-label 0)
			       (send self :variable-label 0) "")
		      :text-length 10))
	 
	 (prompty (send text-item-proto :new "Y-label:"))
	 (namey (send edit-text-item-proto
		      :new (if (send self :variable-label 1)
			       (send self :variable-label 1) "")
		      :text-length 10))
	 
	 (lines (send toggle-item-proto :new "Lines" :value *lines*))
	 (overlay (send toggle-item-proto :new "Toggle overlay" :value nil))
	 (use-color (send toggle-item-proto
			  :new "Use color" :value (if *use-color* t nil)))
	 (psplot (send toggle-item-proto :new "Postscript file" :value nil))
	 (labels (send toggle-item-proto :new "Add/Arrange labels" :value nil))
	 
	 (x-items (list "selecting" "brushing" "zoom-in" "hand-rotate"))
	 (x-item-symbols '(selecting brushing zoom-in hand-rotate))
	 (x-item (send choice-item-proto :new x-items :value 2))
	 
	 (colors (list "Black" "Blue " "Green" "Red  "))
	 (colorsyms '(Black Blue Green Red))
	 (y-item (send choice-item-proto :new colors :value 0))

	 (cancel (send modal-button-proto :new "Cancel"))
	 (ok
	  (send modal-button-proto
		:new "OK"
		:action #'(lambda() t)))
	 (items 
	  (send modal-dialog-proto :new
		(list
		 (list
		  (list y-label y-item)
		  (list x-label x-item)
		  (list toggle-label lines overlay use-color psplot labels)
		  )
		 (list promptx namex prompty namey)
		 (list prompt name)
		 (list ok cancel)
		 )
		:default-button ok
		))
	 )
    
    (setf items (send items :modal-dialog))
    (if items
	(let(
	     (name (send name :text))
	     (y-item (send y-item :value))
	     (x-item (send x-item :value))
	     )
	  (if (not (equalp name "")) (send self :title name))
	  (if y-item (draw-color (nth y-item colorsyms)))
	  (if x-item (send self :mouse-mode (nth x-item x-item-symbols)))
	  (lines (if (send lines :value) on off))
	  (if (send overlay :value) (send self :toggle-overlay-mode))
	  (if (send psplot :value) (send self :postscript-image))
	  (use-color (send use-color :value))
	  (send self :variable-label 0 (send namex :text))
	  (send self :variable-label 1 (send namey :text))
	  (if (send labels :value) (send self :make-labels))
	  (send self :plot-item)
	  )
      )
    )
  )

;; Modelled after mouse-mode-item-proto, found in graphics.lsp
;; 								AEL
;; OVERLAY-MODE-ITEM-PROTO. Rotates among overlay on, and off
(defproto overlay-mode-item-proto '(graph) () menu-item-proto
  "Menu item for changing the overlay mode")

(defmeth overlay-mode-item-proto :isnew (v)
  (setf (slot-value 'graph) v)
  (call-next-method "Toggle Overlay Mode"))

(defmeth overlay-mode-item-proto :do-action ()
  (let ((graph (slot-value 'graph)))
    (send graph :toggle-overlay-mode)))

(defmeth graph-proto :overlay-modes ()
  "Method args: ()
Returns a list of the current overlay modes."
  '("on" "off"))

(defmeth graph-proto :choose-overlay-mode ()
  "Method args: ()
Presents a dialog to set the overlay mode."
  (let* ((modes (send self :overlay-modes))
         (m (choose-item-dialog "New Mode:" modes
                                :initial (position (send self :overlay-modes)
                                                   modes))))
    (if m
	(list
	 (if (equalp (nth m modes) "on")
	     (let()
	       (send self :add-overlay
		     (send scatterplot-control-overlay-proto :new))
	       (send self :margin 0 0 0 20)
	       )
	   (send self :delete-overlay (first (send self :slot-value 'overlays)))
	   )
	 (send self :redraw)
	 )))
  )

(defmeth graph-proto :toggle-overlay-mode ()
  "Method args: ()
Presents a dialog to set the overlay mode."
  (let* ((modes (send self :overlay-modes))
         (m (first (send self :slot-value 'overlays))))
    (if m
	(send self :delete-overlay (first (send self :slot-value 'overlays)))
      (let()
	(send self :add-overlay
	      (send scatterplot-control-overlay-proto :new))
	(send self :margin 0 0 0 20)
	)
      )
    (send self :redraw)
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Mouse-modes for graph-proto
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(send graph-proto :add-mouse-mode
      'center-on :title "Center on..." :click :center-on-it)
(send graph-proto :add-mouse-mode 'zoom :title "Zoom!" :click :zoom)
(send graph-proto :add-mouse-mode
      'zoom-box :title "Zoom-Box!" :click :zoom-box) 
(send graph-proto :add-mouse-mode
      'show-coordinates :title "Show Coordinates" :cursor 'finger 
      :click :do-show-coordinates)
(send graph-proto :add-mouse-mode
      'zoom-in :title "Zoom in" :cursor 'cross :click :do-zoom-in)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			spin-proto methods
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  		method spin-proto :plot-item (&optional new)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth spin-proto :plot-item (&optional new)
  "
	Not so sophisticated for the spin-proto, yet! But I can add in a
function, points, or lines.

;; Examples:
 (plot {x*y :v '(x y)})
 (send my-plot :add-plot-item (list 'function {x+y :v '(x y)}))
 (send my-plot
   :add-plot-item
   (list 'lines (list 1 0) (list 1 0) (list 1 2)
         :color 'yellow :type 'dashed :width 3))
 (send my-plot
   :add-plot-item
   (list 'points (list 1 0) (list 1 0) (list 1 2)
   :color 'yellow :symbol 'wedge1 :point-labels (list \"hi\" \"lo\")))
"
  (andy-print "In spin-proto plot-itemmmmm.")
  (when new (setf (slot-value 'plot-item) new))
  (let (
	(stuff-to-plot (slot-value 'plot-item))
	(line-color 'white)
	self.domain self.range xmin xmax
	x-coords-of-text
	y-coords-of-text
	z-coords-of-text
	texts
	)
    (if stuff-to-plot
	(dolist
	 (i (if (listp stuff-to-plot) stuff-to-plot (list stuff-to-plot)))
	 (cond
	  ((functionp i)
	   nil
	   )
	  ((listp i)
	   (let* (
		  (keys
		   (catch-keys
		    '(:color :symbol :point-labels :width :type :num-points
			     :xmin :xmax :ymin :ymax) i)
		   )
		  (color (elt keys 0))
		  (symbol (elt keys 1))
		  (point-labels (elt keys 2))
		  (width (elt keys 3))
		  (type (elt keys 4))
		  (num-points (elt keys 5))
		  (xmin (elt keys 6))
		  (xmax (elt keys 7))
		  (ymin (elt keys 8))
		  (ymax (elt keys 9))
		  )
	     (cond
	      ((stringp (first i))
	       (setq texts (combine texts (first i))
		     x-coords-of-text (combine x-coords-of-text (second i))
		     y-coords-of-text (combine y-coords-of-text (third i))
		     z-coords-of-text (combine z-coords-of-text (fourth i)))
	       )
	      ((equal (first i) 'points)
	       (send self :add-points
		     (list
		      (second i)
		      (third i)
		      (fourth i)
		      )
		     :color (if color color line-color)
		     :symbol (if symbol symbol *plot-symbol*)
		     :point-labels (if point-labels point-labels nil)
		     )
;;;
;;; The following redraw appears to be necessary in order to get the plot
;;; symbols to work - unfortunately, it obliterates any text in the field. To
;;; take care of that, I add all text last:
;;;
;;	       (send self :redraw)
	       )
	      ((equal (first i) 'lines)
	       (send self :add-lines
		     (list
		      (second i)
		      (third i)
		      (fourth i)
		      )
		     :color (if color color line-color)
		     :width (if width width *line-width*)
		     :type (if type type *line-type*)
		     )
	       )
	      ((equal (first i) 'function)
	       (send self :add-function
		     (second i)
		     (if xmin xmin (first *spin-domain*))
		     (if xmax xmax (second *spin-domain*))
		     (if ymin ymin (third *spin-domain*))
		     (if ymax ymax (fourth *spin-domain*))
		     :color (if color color line-color)
		     :width (if width width *line-width*)
		     :type (if type type *line-type*)
		     :num-points (if num-points num-points *spin-points*)
		     )
	       )
	      (t ; this should be a trio of list (or vectors), which will be
					; plotted:
	       (if *lines*
		   (send self 
			 :add-lines
			 (list
			  (first i)
			  (second i)
			  (third i)
			  )
			 :color (if color color line-color)
			 :width (if width width *line-width*)
			 :type (if type type *line-type*)
			 )
		 ;; otherwise, points:
		 (let ()
		   (send self :add-points
			 (list
			  (first i)
			  (second i)
			  (third i)
			  )
			 :color (if color color line-color)
			 :symbol (if symbol symbol *plot-symbol*)
			 :point-labels (if point-labels point-labels nil)
			 )
		   )
		 )
	       )
	      )
	     )
	   )
	  )
	 )
      )
    (if texts
	(send self :add-points
	      (mapcar
	       #'rest
	       (list x-coords-of-text y-coords-of-text z-coords-of-text)
	       )
	      :color *draw-color*
	      :point-labels (rest texts))
      )
    )
  (andy-print "plot-item farewell: ")
  (slot-value 'plot-item)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                           :add-plot-item
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth spin-proto :add-plot-item (&rest e)
  "
;; Description:

	spin-proto :add-plot-item (&rest e)

	I'm continually adding things that can be added to a plot. For the
moment the list includes lines, points, functions.

;; Examples:
 (plot (rand.n 10) (rand.n 10) (rand.n 10))
 (send my-plot :add-plot-item
   (list \"hi\" .4 .5 .2)
   (list 'points (rand.u 10) (rand.u 10) (rand.u 10) :color 'yellow
         :point-labels (mapcar #'num-to-string (iseq 3 12)))
   :draw t)

 (plot (rand.n 10) (rand.n 10) (rand.n 10))
 (send my-plot :add-plot-item
   (list \"hi\" .4 .5 .2)
   (list 'points (rand.u 10) (rand.u 10) (rand.u 10) :color 'yellow
         :point-labels (mapcar #'num-to-string (iseq 3 12)))
   )
"
  (let (
	(draw (first (catch-keys '(:draw) e)))
	(e (remove-keys '(:draw) e))
	)
    (if draw
	(let ()
	  (send self :plot-item (append (slot-value 'plot-item) e))
	  ;;; ael: (send self :redraw)
	  )
      (setf (slot-value 'plot-item) (append (slot-value 'plot-item) e))
      )
    )
  nil
  )

#|
	This from the ViSta package: I liked it lots!

;; set up local environment with function to project (x, y) point onto
;; "globe" over the plot
(flet ((calcsphere (x y)
		   (let* ((norm-2 (+ (* x x) (* y y)))
			  (rad-2 (^ 1.7 2))
			  (z (if (< norm-2 rad-2) (sqrt (- rad-2 norm-2)) 0)))
		     (if (< norm-2 rad-2) 
			 (list x y z)
		       (let ((r (sqrt (max norm-2 rad-2))))
			 (list (/ x r) (/ y r) (/ z r)))))))
      
      ;; define the :DO-HAND-ROTATE method in the local environment
      (defmeth spin-proto :do-hand-rotate (x y m1 m2)
	(let* ((oldp (apply #'calcsphere 
			    (send self :canvas-to-scaled x y)))
	       (p oldp)
	       (vars (send self :content-variables))
	       (trans (identity-matrix (send self :num-variables))))
	  (send self :idle-on nil)
	  (send self :while-button-down 
		#'(lambda (x y) 
		    (setf oldp p)
		    (setf p (apply #'calcsphere 
				   (send self :canvas-to-scaled x y)))
		    (setf (select trans vars vars) (make-rotation oldp p))
		    (when m1 
			  (send self :slot-value 'rotation-type trans)
			  (send self :idle-on t))
		    (send self
			  :apply-transformation
			  trans)))))
      )

|#
;; add a new "mouse mode", with menu title, cursor and mouse method name
(send spin-proto :add-mouse-mode 'hand-rotate
      :title "Hand Rotate" :cursor 'hand :click :do-hand-rotate)

;; set up local environment with function to project (x, y) point onto
;; "globe" over the plot
(flet ((calcsphere (x y)
		   (let* ((norm-2 (+ (* x x) (* y y)))
			  (rad-2 (^ 1.7 2))
			  (z (if (< norm-2 rad-2) (sqrt (- rad-2 norm-2)) 0)))
		     (if (< norm-2 rad-2) 
			 (list x y z)
		       (let ((r (sqrt (max norm-2 rad-2))))
			 (list (/ x r) (/ y r) (/ z r)))))))
      
      ;; define the :DO-HAND-ROTATE method in the local environment
      (defmeth spin-proto :do-hand-rotate (x y m1 m2)
	(let* ((oldp (apply #'calcsphere 
			    (send self :canvas-to-scaled x y)))
	       (p oldp)
	       (vars (send self :content-variables))
	       (trans (identity-matrix (send self :num-variables))))
	  (send self :idle-on nil)
	  (send self :while-button-down 
		#'(lambda (x y) 
		    (setf oldp p)
		    (setf p (apply #'calcsphere 
				   (send self :canvas-to-scaled x y)))
		    (setf (select trans vars vars) (make-rotation oldp p))
		    (when m1 
			  (send self :slot-value 'rotation-type trans)
			  (send self :idle-on t))
		    ;; (print (solve (send self :transformation) '(0 0 1)))
		    (send self
			  :apply-transformation
			  trans)
		    ;; ael
		    ))
	  (if (send self :linked)
	      (dolist (i (agw))
		      (if (and
			   (neq i self)
			   (send i :linked)
			   )
			  (let ()
			    (send i :transformation (send self :transformation))
			    (send i :show-window)
			    )
			)
		      )
	    )
	  (send self :show-window)
	  ;; ael
	  )
	)
      )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                       spin do-key, and some methods
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth spin-proto :change-range ()
  "
Changes the range, using the get-value-dialog.
"
  (let* (
	 (location (send self :location))
	 (zmin (first (get-value-dialog "zmin" :location location)))
	 (zmax (if zmin (first (get-value-dialog "zmax" :location location))))
	 )
    (if (and zmin zmax)
	(list
	 (send self :range 2 zmin zmax)
	 (send self :plot-item)
	 )
      )
    )
  )

(defmeth spin-proto :change-domain-and-range ()
  "
Changes the domain and range, using the get-value-dialog.
"
  (let* (
	 (location (send self :location))
	 (xmin (first (get-value-dialog "xmin" :location location)))
	 (xmax (if xmin (first (get-value-dialog "xmax" :location location))))
	 (ymin (first (get-value-dialog "ymin" :location location)))
	 (ymax (if ymin (first (get-value-dialog "ymax" :location location))))
	 )
    (if (and xmin xmax) (send self :range 0 xmin xmax))
    (if (and ymin ymax) (send self :range 1 ymin ymax))
    (if (or (and xmin xmax) (and ymin ymax)) (send self :plot-item))
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                hidden
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth spin-proto :hidden (&key patch)
  "
;; Description: spin-proto :hidden (&key patch)

	Hidden-line plot of a function of two-variables.

;; Examples:
 (plot (lambda(x y) (* x y)))
 (send my-plot :hidden)
 (send my-plot :hidden :patch t)
"
  (hid :plot self :patch patch)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                do-key
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth spin-proto :do-key (c m1 m2)
  "
  The following keys are currently defined: typing them while a spin plot
is active will give the following results:

                        h - help (this message)

d - change domain       r - change range		v - shrinks plot
p - replot the item     q - remove the plot		V - grows plot

			b - hidden line removal

l - make the window large (of full screen-size)
s - make the window small (300 by 300)
t - report the current transformation

m,n - roll		M,N - pitch		<,> (or ,,.) - yaw

1 - hand-rotate mouse-mode
2 - generates a pair of stereo images (copies of the original)
3 - brushing mouse-mode
4 - choose mouse mode
5 - selecting mouse-mode
"
  (case c
	(#\h (princ
"
  The following keys are currently defined: typing them while a spin plot is
active will give the following results:

                        h - help (this message)

d - change domain       r - change range		v - shrinks plot
p - replot the item     q - remove the plot		V - grows plot

			b - hidden line removal

l - make the window large (of full screen-size)
s - make the window small (300 by 300)
t - report the current transformation

m,n - roll		M,N - pitch		<,> (or ,,.) - yaw

1 - hand-rotate mouse-mode
2 - generates a pair of stereo images (copies of the original)
3 - brushing mouse-mode
4 - choose mouse mode
5 - selecting mouse-mode
")
	 )
	(#\b (send self :hidden))
	(#\d (send self :change-domain-and-range))
	(#\i (send self :help))
	(#\l
	 (let (
	       (screen-size (screen-size))
	       )
	   (send self :location 0 20)
	   (send self :size (first screen-size) (- (second screen-size) 20))
	   )
	 )
	(#\m
	 (send self :rotation-type 'rolling)
	 (send self :rotate)
	 )
	(#\M
	 (send self :rotation-type 'pitching)
	 (send self :rotate)
	 )
	(#\n
	 (send self :rotation-type 'rolling)
	 (send self :angle (- (send self :angle)))
	 (send self :rotate)
	 (send self :angle (- (send self :angle)))
	 )
	(#\N
	 (send self :rotation-type 'pitching)
	 (send self :angle (- (send self :angle)))
	 (send self :rotate)
	 (send self :angle (- (send self :angle)))
	 )
	(#\p (send self :plot-item))
	(#\P (send self :postscript-image))
	(#\q (send self :remove))
	(#\Q (send self :remove))
	(#\r (send self :change-range))
	(#\s (send self :size 300 300))
	(#\t (mprint (send self :transformation)))
	(#\v (let((size (send self :size)))
	       (send self :size
		     (floor (* .9 (first size)))
		     (floor (* .9 (second size))))))
	(#\V (let((size (send self :size)))
	       (send self :size
		     (floor (* 1.1 (first size)))
		     (floor (* 1.1 (second size))))))
	(#\1 (send self :mouse-mode 'hand-rotate))
	(#\2 (send self :stereo))
	(#\3 (send self :mouse-mode 'brushing))
	(#\4 (send self :choose-mouse-mode))
	(#\5 (send self :mouse-mode 'selecting))
	(#\.
	 (send self :rotation-type 'yawing)
	 (send self :rotate)
	 )
	(#\>
	 (send self :rotation-type 'yawing)
	 (send self :rotate)
	 )
	(#\,
	 (send self :rotation-type 'yawing)
	 (send self :angle (- (send self :angle)))
	 (send self :rotate)
	 (send self :angle (- (send self :angle)))
	 )
	(#\<
	 (send self :rotation-type 'yawing)
	 (send self :angle (- (send self :angle)))
	 (send self :rotate)
	 (send self :angle (- (send self :angle)))
	 )
	)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                   line methods for spin-proto
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#|
	I stole these from gnuplot, to get at a three-d plot.
But I changed the whiles to do loops, as "while don't compile":
|#
(defmeth spin-proto :get-line (start)
  ":get-line 0 "
  (let (xcoords ycoords zcoords)
    (do
     ((next start (send self :linestart-next next)))
     ((not next))
     (setq
      xcoords (cons (send self :linestart-coordinate 0 next) xcoords)
      ycoords (cons (send self :linestart-coordinate 1 next) ycoords)
      zcoords (cons (send self :linestart-coordinate 2 next) zcoords))
     )
    (list xcoords ycoords zcoords)
    )
  )

(defmeth spin-proto :getlines ()
  "This method produces the three-d lines in a spin-plot. Returns the lines of
self in a list of lists format."
  (let (
	(last (send self :num-lines))
	resul
	)
    (do
     ((first 0 (+ first (length (first aline)))))
     ((>= first last))
     (setq
      aline (send self :get-line first)
      resul (cons aline resul))
     )
    resul
    )
  )

#|
(defmeth spin-proto :3d-2d ()
  ":3d-2d () takes the three-d lines and give the 2-d canvas coordinates"
  (let (
	(first 0)
	(last (send self :num-lines))
	aline 
	resul
	(mat (matprod (send self :transformation)
		      (diagonal-to-matrix (/ (send self :scale (iseq 3))))))
	)
    (WHILE (< first last)
	   (setf aline
		 (select
		  (row-list
		   (matprod
		    mat
		    (apply #'bind-rows (send self :get-line first))
		    )
		   )
		  (iseq 2)
		  )
		 )
	   (setq resul (cons aline resul)
		 first (+  first (length (first aline)))))
    resul))

|#
(defmeth spin-proto :3d-2d ()
  ":3d-2d () takes the three-d lines and give the 2-d canvas coordinates"
  (let (
	(last (send self :num-lines))
	aline 
	resul
	(mat (matprod (send self :transformation)
		      (diagonal-to-matrix (/ (send self :scale (iseq 3))))))
	)
    (do
     ((first 0 (+ first (length (first aline)))))
     ((>= first last))
     (setf aline
	   (select
	    (row-list
	     (matprod
	      mat
	      (apply #'bind-rows (send self :get-line first))
	      )
	     )
	    (iseq 2)
	    )
	   )
     (setq resul (cons aline resul))
     )
    resul)
  )

(defmeth spin-proto :3d-2d-points ()
  "this method takes the three-d points and give the 2-d canvas coordinates,
plus any label.
"
  (let* (
	 (last (send self :num-points))
	 (x (send self :point-coordinate 0 (iseq last)))
	 (y (send self :point-coordinate 1 (iseq last)))
	 (z (send self :point-coordinate 2 (iseq last)))
	 (names (send self :point-label (iseq last)))
	 resul
	 (mat (matprod (send self :transformation)
		       (diagonal-to-matrix (/ (send self :scale (iseq 3))))))
	 )
    (setf resul (row-list (matprod mat (bind-rows x y z)))
	  resul (weave
		 (coerce (first resul) 'list)
		 (coerce (second resul) 'list)
		 names
		 ))
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				:stereo
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth spin-proto :stereo ()
  (when
   (functionp (first (send self :plot-item)))
   (defproto andyspin-stereo-proto nil nil andyspin-proto)
   (let* (
	  (func (first (send self :plot-item)))
	  (sd *spin-domain*)
	  (plot (apply #'send andyspin-stereo-proto :new 3 :show nil nil))
	  (shadow (apply #'send andyspin-stereo-proto :new 3 :show nil nil))
	  (linked-plots (list plot shadow))
	  (xmin (elt sd 0))
	  (xmax (elt sd 1))
	  (ymin (elt sd 2))
	  (ymax (elt sd 3))
	  (size 200) (i 0) (eps .1)
	  (factor 1)
	  )

     ;; set up local environment with function to project (x, y) point onto
     ;; "globe" over the plot
     (flet ((calcsphere
	     (x y)
	     (let* ((norm-2 (+ (* x x) (* y y)))
		    (rad-2 (^ 1.7 2))
		    (z (if (< norm-2 rad-2) (sqrt (- rad-2 norm-2)) 0)))
	       (if (< norm-2 rad-2) 
		   (list x y z)
		 (let ((r (sqrt (max norm-2 rad-2))))
		   (list (/ x r) (/ y r) (/ z r)))))))
	   
	   ;; define the :DO-HAND-ROTATE method in the local environment
	   (defmeth andyspin-stereo-proto :close ()
	     (mapcar (lambda(x) (send x :dispose)) linked-plots))
	   
	   (defmeth andyspin-stereo-proto :do-hand-rotate (x y m1 m2)
	     (let* ((oldp (apply #'calcsphere 
				 (send self :canvas-to-scaled x y)))
		    (p oldp)
		    (vars (send self :content-variables))
		    (trans (identity-matrix (send self :num-variables)))
		    )
	       (send self :idle-on nil)
	       (send self :while-button-down 
		     #'(lambda (x y) 
			 (setf oldp p
			       p (apply #'calcsphere 
					(send self :canvas-to-scaled x y))
			       (select trans vars vars) (make-rotation oldp p))
			 (when m1 
			       (send self :slot-value 'rotation-type trans)
			       (send self :idle-on t))
			 (mapcar
			  (lambda(x) (send x :apply-transformation trans))
			  linked-plots)
			 ;; ael
			 ))
	       (send self :show-window)
	       ;; ael
	       )
	     )
	   )

     (dolist
      (plot linked-plots)
      (apply #'send plot :add-function func xmin xmax ymin ymax :draw nil
	     :num-points *SPIN-POINTS* :spline *SPIN-SPLINE* nil)
      (send plot :adjust-to-data :draw nil)
      (send plot :new-menu)
      (send plot :rotate-2 0 1 (* factor (/ pi 3)) :draw nil)
      (send plot :rotate-2 1 2 (- (/ pi 3)) :draw nil)
      (send plot :size size size)
      (send plot :location (+ i size) 40)
      (setq i (+ i size)
	    factor (+ factor eps))
      (send plot :mouse-mode 'hand-rotate)
      )

     (mapcar (lambda(x) (send x :show-window)) linked-plots)
     )
   )
  )


#|
(defmeth spin-proto :do-hand-job (x y m1 m2)
  (let* ((oldp (apply #'calcsphere 
		      (send self :canvas-to-scaled x y)))
	 (p oldp)
	 (vars (send self :content-variables))
	 (trans (identity-matrix (send self :num-variables))))
    (send self :idle-on nil)
    (send self :while-button-down 
	  #'(lambda (x y) 
	      (setf oldp p)
	      (setf p (apply #'calcsphere 
			     (send self :canvas-to-scaled x y)))
	      (printall oldp p (list x y) vars (send self :canvas-to-scaled x y))
	      (setf (select trans vars vars) (make-rotation oldp p))
	      (mprint (make-rotation oldp p))
	      (when m1 
		    (send self :slot-value 'rotation-type trans)
		    (send self :idle-on t))
	      ;; (print (solve (send self :transformation) '(0 0 1)))
	      (send self
		    :apply-transformation
		    trans)
	      ;; ael
	      ))
    (if (send self :linked)
	(dolist (i (agw))
		(if (and
		     (neq i self)
		     (send i :linked)
		     )
		    (let ()
		      (send i :transformation (send self :transformation))
		      (send i :show-window)
		      )
		  )
		)
      )
    ))
(send spin-proto :add-mouse-mode 'hand-job
      :title "Hand Job" :cursor 'hand :click :do-hand-job)

(defun calcsphere (x y)
                   (let* ((norm-2 (+ (* x x) (* y y)))
                          (rad-2 (^ 1.7 2))
                          (z (if (< norm-2 rad-2) (sqrt (- rad-2 norm-2)) 0)))
                     (if (< norm-2 rad-2)
                         (list x y z)
                       (let ((r (sqrt (max norm-2 rad-2))))
                         (list (/ x r) (/ y r) (/ z r))))))
|#

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				:postscript-image
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth spin-proto :postscript-image ()
  "Method args: ()
Opens dialog to set postscript image filename.
;; See Also: postscript-3d
"
  (let ((name
	 (get-string-dialog
	  "Postscript Filename:
 (.ps extension added automatically)"
			    :location (send self :location))
	 ))
    (if name (postscript-3d (strcat name ".ps") :plot self))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                       histogram do-key, and some methods
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth histogram-proto :change-range ()
  "
Changes the range, using the get-value-dialog.
"
  (let* (
	 (location (send self :location))
	 (ymin (first (get-value-dialog "ymin" :location location)))
	 (ymax (if ymin (first (get-value-dialog "ymax" :location location))))
	 )
    (if (and ymin ymax)
	(list
	 (send self :range 1 ymin ymax)
	 (send self :plot-item)
	 )
      )
    )
  )

(defmeth histogram-proto :change-domain ()
  "
Changes the domain and range, using the get-value-dialog.
"
  (let* (
         (location (send self :location))
	 (xmin (first (get-value-dialog "xmin" :location location)))
	 (xmax (if xmin (first (get-value-dialog "xmax" :location location))))
	 )
    (if (and xmin xmax) (send self :range 0 xmin xmax))
    (if (and xmin xmax) (send self :plot-item))
    )
  )

(defmeth histogram-proto :change-bins ()
  "
Changes the number of bins, using the get-value-dialog.
"
  (let* (
         (location (send self :location))
	 (numbins
	  (first (get-value-dialog "Number of Bins:" :location location)))
	 )
    (if numbins (send self :num-bins numbins))
    )
  )

(defmeth histogram-proto :do-key (c m1 m2)
  "
  The following keys are currently defined: typing them while a histogram plot
is active will give the following results:

                        h - help (this message)

d - change domain       r - change range       i - info (send :help command)
p - replot the item     q - remove the plot

l - make the window large (of full screen-size)
s - make the window small (250 by 250)
"
  (case c
	(#\h (princ
"
  The following keys are currently defined: typing them while a histogram plot
is active will give the following results:

                        h - help (this message)

d - change domain       r - change range       b - change number of bins
p - replot the item     q - remove the plot    n - bin counts

l - make the window large (of full screen-size)
s - make the window small (250 by 250)
")
	 )
	(#\b (send self :change-bins))
	(#\n (print (print (send self :bin-counts))))
	(#\i (send self :help))
	(#\d (send self :change-domain))
	(#\r (send self :change-range))
	(#\l
	 (let (
	       (screen-size (screen-size))
	       )
	   (send self :location 0 20)
	   (send self :size (first screen-size) (- (second screen-size) 20))
	   )
	 )
	(#\s (send self :size 250 250))

	(#\p (send self :plot-item))
	(#\q (send self :remove))
	)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			:clear-content
;;
;; Sun May 24 10:05:38 1998
;; Yesterday I was glancing through Lukes's changes.tex file, and discovered
;; the clear-content method. I have now replaced redraw modifications
;; (previously in the file labels.lsp) with clear-content modifications.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth histogram-proto :clear-content ()
  (call-next-method)
  (if (send self :has-slot 'jason-horiz-vert)
      (let* (
	     (v-h (send self :jason-horiz-vert))
	     (horiz (send self :jason-horiz))
	     (vert (send self :jason-vert))
	     (method
	      (mapcar
	       #'(lambda (x) (if (= x 0) :draw-text :draw-text-up))
	       v-h))
	     (coords (send self :jason-label-coordinates))
	     (labels (send self :jason-plot-labels))
	     )
	(mapcar
	 #'(lambda (x y z h v) (send self z x (first y) (second y) h v))
	 labels coords method horiz vert))))

#|
Doesn't work! Rats! That would have been too easy. Instead I have the rather
kludgy readtable file.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                       listener-proto do-key, and some methods
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth window-proto :do-key (c m1 m2)
  (case c
	(#\c-t (tutorials))
	(#\c-p (history))
	(#\c-l
	 (let (
	       (screen-size (screen-size))
	       )
	   (send self :location 0 20)
	   (send self :size (first screen-size) (- (second screen-size) 20))
	   )
	 )
	(#\c-s
	 (send self :location 0 20)
	 (send self :size 250 250)
	 )
	)
  )

|#

